/* Practica 12 */
/* Manejo de colas */
/* Jose Mariscal 
Prieto */

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

struct cola
{
char fichero[30],usuario[30];
int bytes,id;
struct cola *siguiente;
};

struct ficha_cola
{
struct cola *principio,*fin;
};

struct sincola
{
char fichero[30],usuario[30];
int bytes,id;
};

int menu(void);
void pulsartecla(void);
void crear(struct ficha_cola**);
void meter_en_cola(struct ficha_cola*,struct sincola);
int vacia(struct ficha_cola*);
void listar(struct ficha_cola*);
int sacar_de_la_cola(struct ficha_cola*);
struct sincola primero_en_cola(struct ficha_cola*);
struct sincola ultimo_en_cola(struct ficha_cola*);
void borrar_de_la_cola(struct ficha_cola*,int);

/*************************** FUNCION PRINCIPAL ****************************/

main()
{
struct ficha_cola *impresion;
struct sincola trabajo;
int opc,control;
crear(&impresion);
do
	{
	opc=menu();
	switch(opc)
		{
		case 1: system("clear");
			printf("AADIR UN TRABAJO A LA COLA DE IMPRESION\n");
			printf("------------------------------------------------------------------------\n\n");
			printf("Nombre del fichero: ");
			scanf("%s",&trabajo.fichero); /* linux */
/*			gets(trabajo.fichero);
 SOLARIS */
			printf("Tamao del fichero: ");
			scanf("%d",&trabajo.bytes);
			fflush(stdin);
			printf("Nombre del usuario: ");
			scanf("%s",&trabajo.usuario); /* linux */
/*			gets(trabajo.usuario);
 SOLARIS */
			printf("Identificador del trabajo: ");
			scanf("%d",&trabajo.id);
			fflush(stdin);
			meter_en_cola(impresion,trabajo);
			break;
                case 2: control=sacar_de_la_cola(impresion);
                        if(control==0)
                                printf("\nNo existe ningn fichero en la cola de impresin.");
                        else
                                printf("\nEl primer fichero de la cola de impresin ha sido imprimido.");
                        pulsartecla();
                        break;
                case 3: system("clear");
			printf("LISTADO DE LOS TRABAJOS ACTUALES DE LA COLA DE IMPRESION\n");
			printf("------------------------------------------------------------------------\n\n");
                        if(vacia(impresion))
                                {
                                printf("La cola de impresin est vaca.");
                                pulsartecla();
                                }
                        else
                                listar(impresion);
			break;
                case 4: system("clear");
                        printf("BORRARDO DE UN FICHERO DE LA COLA DE IMPRESION\n");
                        printf("------------------------------------------------------------------------\n\n");
                        if(vacia(impresion))
                                {
                                printf("La cola de impresin est vaca.");
                                pulsartecla();
                                }
                        else
                                {
                                printf("Introduce el identificador del trabajo a borrar: ");
                                scanf("%d",&trabajo.id);
                                fflush(stdin);
                                borrar_de_la_cola(impresion,trabajo.id);
                                }
                        break;                                
                case 5: system("clear");
			printf("------------------------------------------------------------------------\n\n");
			exit(0);
		}
	}while(opc!=5);
}


/* funcion menu */
/* es de tipo entero, muestra el menu de opciones y devuelve un entero, la
opcion elegida */


int menu(void)
{
int opc;
do
	{
	system("clear");
	printf("***************************************************************\n");
	printf("*** 			MENU DE OPCIONES                    ***\n");
	printf("*** ------------------------------------------------------- ***\n");
	printf("*** 1. Aadir un trabajo a la cola de impresin             ***\n");
	printf("*** 2. Imprimir un trabajo				    ***\n");
	printf("*** 3. Listar los trabajos de la cola de impresin	    ***\n");
	printf("*** 4. Eliminar un trabajo de la cola de impresin	    ***\n");
	printf("*** 5. Salir del programa				    ***\n");
	printf("*** ------------------------------------------------------- ***\n");
	printf("***************************************************************\n\n");
	printf("Elige una opcin: ");
	scanf("%d",&opc);
	fflush(stdin);
        if(opc<1 || opc>5)
		{
		printf("\nOpcin incorrecta.");
		pulsartecla();
		}
	}while(opc<1 || opc>5);
return opc;
}


/* funcion pulsar tecla */
/* realiza una pausa en el programa hasta que se pulse intro */

void pulsartecla(void)
{
printf("\nPulse Intro para continuar...\n");
getchar();
}

/* funcion crear */
/* crea una cola, es de tipo void y no devuelve nada, recibe un puntero doble
**cola a la estructura ficha_cola */

void crear(struct ficha_cola **cola)
{
*cola=(struct ficha_cola*)malloc(sizeof(struct ficha_cola));
(*cola)->principio=NULL;
(*cola)->fin=NULL;
}

/* funcion meter en la cola */
/* es de tipo void no devuelve nada, inserta un nuevo registro al comienzo
 de la cola */
/* recibe un puntero *cola a la estructura ficha_cola que recoge la cola
en la que se inserta el registro. */
/* recibe un puntero *trabajo que apunta a la estructura sincola,
el elemento que no esta en la cola y se insertara*/

void meter_en_cola(struct ficha_cola *cola,struct sincola trabajo)
{
struct cola *nuevo;
nuevo=(struct cola*)malloc(sizeof(struct cola));
strcpy(nuevo->fichero,trabajo.fichero);
nuevo->bytes=trabajo.bytes;
strcpy(nuevo->usuario,trabajo.usuario);
nuevo->id=trabajo.id;
if(vacia(cola))
	{
	cola->principio=nuevo;
	cola->fin=nuevo;
	}
else
	{
	cola->fin->siguiente=nuevo;
	cola->fin=nuevo;
	}
}

/* funcion vacia */
/* es de tipo entero devuelve un 1 si la cola esta vacia */
/* recibe un puntero *cola a la estructura ficha_cola, que recoge la cola a
comprobar si esta vacia */

int vacia(struct ficha_cola *cola)
{
if(cola==NULL)
        return 1;
else
        return((cola->principio)?0:1);
}

/* funcion primero en cola */
/* devuelve una estructura que es el primer registro que hay en la cola */
/* recibe un puntero *cola a la estructura fica_cola que recoge la cola
en la que se busca el registro */
 
struct sincola primero_en_cola(struct ficha_cola *cola)
{
struct sincola trabajo;
strcpy(trabajo.fichero,cola->principio->fichero);
trabajo.bytes=cola->principio->bytes;
strcpy(trabajo.usuario,cola->principio->usuario);
trabajo.id=cola->principio->id;
return trabajo;
}

/* funcion ultimo en cola */
/* devuelve una estructura, que es el ultimo registro de la cola */
/* recibe un puntero *cola a la estructura ficha_cola que es la cola en la
 que se 
buscara el registro */

struct sincola ultimo_en_cola(struct ficha_cola *cola)
{
struct sincola trabajo;
strcpy(trabajo.fichero,cola->fin->fichero);
trabajo.bytes=cola->fin->bytes;
strcpy(trabajo.usuario,cola->fin->usuario);
trabajo.id=cola->fin->bytes;
return trabajo;
}

/* listar */
/* es de tipo void y no fdevuelve nada, muestra en pantalla todos los
 registros de la cola */
/* recibe un puntero *cola a la estructura fiche_cola que es la cola de
donde se sacaran los datos */

void listar(struct ficha_cola *cola)
{
struct ficha_cola *auxiliar;
struct sincola trabajo;
crear(&auxiliar);
while(!vacia(cola))
        {
        trabajo=primero_en_cola(cola);
        meter_en_cola(auxiliar,trabajo);
        sacar_de_la_cola(cola);
        }
while(!vacia(auxiliar))
        {
        trabajo=primero_en_cola(auxiliar);
        meter_en_cola(cola,trabajo);
        sacar_de_la_cola(auxiliar);
        printf("\nFichero: %s\n",trabajo.fichero);
        printf("Tamao: %d\n",trabajo.bytes);
        printf("Usuario: %s\n",trabajo.usuario);
        printf("Identificador: %d\n",trabajo.id);
        printf("--------------------------------\n");
        pulsartecla();
        }
}

/* sacar de la cola */
/* es de tipo enterom devuelve un q si se borra el primer registro y un 0
en caso contrario */
/* recibe un puntero *cola a la estructura ficha_cola que es la cola de
donde se borrara el primer registro*/

int sacar_de_la_cola(struct ficha_cola *cola)
{
struct cola *auxiliar;
if(vacia(cola))
        return 0;
else
        if(cola->principio==cola->fin)
                {
                auxiliar=cola->principio;
                cola->principio=NULL;
                cola->fin=NULL;
                free(auxiliar);
                return 1;
                }
         else
                {
                auxiliar=cola->principio;
                cola->principio=cola->principio->siguiente;
                auxiliar->siguiente=NULL;
                free(auxiliar);
                return 1;
                }
}

/* funcion borrar de la cola */
/* borra de la cola un registro dado su identificacion */
/* es de tipo void y no devuelve nada, recibe un puntero  *cola a la estructura
ficha_cola que recoge la lista donde se borrara el registro y un entero id que
es la identificacion del registro a borrar*/

void borrar_de_la_cola(struct ficha_cola *cola,int id)
{
struct ficha_cola *auxiliar;
struct sincola trabajo;
int encontrado=0;
crear(&auxiliar);
while(!vacia(cola))
        {
        trabajo=primero_en_cola(cola);
        if(trabajo.id!=id)
                meter_en_cola(auxiliar,trabajo);
        else
                encontrado=1;
        sacar_de_la_cola(cola);
        }
*cola=*auxiliar;
if(encontrado!=1)
        printf("\nEl trabajo a imprimir con el id: %d no ha sido encontrado.",id);
else
        printf("\nEl trabajo con id:%d ha sido borrado de la cola.",id);
pulsartecla();
}
