#include"cabecera.h"
/**************************************************************************
   Funcin:          anadir_cliente

   Descripcin:      Aade cliente si este no existe

   parametros recibidos:char *f_cliente--> nombre del fichero de clientes

   Llamada a funciones:  abrir_fichero
   			 busca_cliente
   			 lee_cliente_teclado	               	**********/

void anadir_cliente(char *f_cliente)
{
  cliente dato;
  char respuesta;
  char nif_pedido[10];
  FILE *fichero;

  abrir_fichero(&fichero,"r+b",f_cliente);

  do
  {

     intr_cadena(nif_pedido,"Nif del cliente");
     dato=busca_cliente(fichero,nif_pedido);

     if(atoi(dato.nif)==-4)/*entra si el cliente no existe */
     {
      	 dato=lee_cliente_teclado(nif_pedido);/*no necesitamos desplazar ptr pq ya esta*/
         fwrite(&dato,1*sizeof(cliente),1,fichero);/*en EOF*/
     }
     else
     	f_error(-5);

     printf("\n\n\tDesea introducir mas clientes ? (S/N) ");
     respuesta=toupper(getchar());
     system("clear");

  }while(respuesta=='S');

  fclose(fichero);
}
/**************************************************************************
   Funcin:          busca_cliente

   Descripcin:      busca en el fichero de clientes uno determinado,devolviendo
                     -4 en el campo NIF si no se encuentra.

   Valor devuelto:   cliente dato --> cliente buscado,o ultimo registro con -4 en
   				      campo nif

   parametros recibidos:FILE *f_binario --> ptr a fichero, se lo pasamos abierto fichero
   			char*nif_buscado --> nif de cliente buscado

   Llamada a funciones:  ninguna                        	**********/

cliente busca_cliente(FILE *f_binario,char *nif_buscado)/*si*/
{
   cliente dato;
   int no_encontrado=0;    /**nos indicara si se ha encontrado**/

   rewind(f_binario);  /*necesario para algunas funciones en las que se
   			llama a esta mas de una vez*/

   while((fread(&dato,sizeof(cliente),1,f_binario))!=0)
   {
       if(strcmp(dato.nif,nif_buscado)==0)
       {
       	  no_encontrado=1;
       	  break;
       }
   }

   if(no_encontrado==0)  /*Lo indicamos fuera de la funcion devolviendo en el */
   	strcpy(dato.nif,"-4");    /*nif de la estructura un -4 */

   return (dato);
}
/**************************************************************************
   Funcin:          listar_clientes

   Descripcin:      Lista el fichero de clientes completo

   parametros recibidos:char *nombre_fichero_binario-->nombre del fichero a listar

   Llamada a funciones:  abrir_fichero
   	                 f_error
   	                 menu_listar
   			 sacar_pantalla_cliente                     	**********/

void listar_clientes(char nombre_fichero_binario[10])
{
     int opc;
     char nombre_fichero_texto[10];
     FILE *f_binario,*f_texto;
     cliente dato;

     abrir_fichero(&f_binario,"rb",nombre_fichero_binario);
     opc=menu_listar();
     	
     switch(opc)
     {
                               /*por pantalla*/
             case 1:while((fread(&dato,sizeof(cliente),1,f_binario))!=0)
                    {
                        system("clear");
                        sacar_pantalla_cliente(dato);
                        pausa();
                    }
	            break;
                                 /*volcado a fichero de texto*/
	     case 2:intr_cadena(nombre_fichero_texto,"Nombre del fichero de salida");
                    f_texto=fopen(nombre_fichero_texto,"w");

                    while((fread(&dato,sizeof(cliente),1,f_binario))!=0)
 	                     fprintf(f_texto,"Nif:%s\nNombre:%s %s %s\nDireccion:%s\n\n",dato.nif,dato.nombre,dato.apellido1,dato.apellido2,dato.direccion);
                    fclose(f_texto);
                    break;

             case 3:break;

             default:f_error(-3);
     }

     fclose(f_binario);
}
/**************************************************************************
   Funcin:          lista_cliente

   Descripcin:      Dado un nif de un cliente,lo lista por pantalla o lo vuelca
   		     a fichero de texto.
   		
   parametros recibidos:char *nombre_fichero_binario-->nombre de fchero de clientes

   Llamada a funciones:  abrir_fichero
   	                 busca_cliente
   	                 menu_listar
   			 f_error
   			 sacar_pantalla_cliente                        	**********/

void lista_cliente(char *nombre_fichero_binario)/*si*/
{
     int opc;
     char nif_pedido[10],nombre_fichero_texto[10];
     FILE *f_binario,*f_texto;
     cliente dato;

     abrir_fichero(&f_binario,"rb",nombre_fichero_binario);
     intr_cadena(nif_pedido,"nif del cliente");

     dato=busca_cliente(f_binario,nif_pedido);

     if(f_error(atoi(dato.nif))) /*funcion atoi ya q dato.nif es una cadena*/
     {
       	opc=menu_listar();
     	
     	switch(opc)
     	{
             case 1:system("clear");     /*por pantalla*/
             	    sacar_pantalla_cliente(dato);
                    pausa();
	            break;
                                       /*volcado a fichero de texto*/
	     case 2:intr_cadena(nombre_fichero_texto,"Nombre del fichero de salida");
                    f_texto=fopen(nombre_fichero_texto,"w");
 	            fprintf(f_texto,"Nif:%s\nNombre:%s %s %s\nDireccion:%s\n\n",dato.nif,dato.nombre,dato.apellido1,dato.apellido2,dato.direccion);
                    fclose(f_texto);
                    break;

             case 3:break;

             default:f_error(-3);
        }
     }
     fclose(f_binario);
}
/**************************************************************************
   Funcin:          modificar_cliente

   Descripcin:      Busca un cliente y modifica cualquiera de los campos de su estructura
   		
   parametros recibidos:char *nombre_fichero_clientes-->

   Llamada a funciones:  abrir_fichero
   	                 busca_cliente
   			 f_error
   			 sacar_pantalla_cliente
   			 mennu_modificar_cliente                        	**********/

void modificar_cliente(char *nombre_fichero_clientes)/*si*/
{
	int opc;
	char cadena[30],nif_pedido[10],nuevo_nif[10];
	char respuesta;
	cliente dato,dato2;
	FILE *f_binario;
	
        intr_cadena(nif_pedido,"nif del cliente a modificar");
	abrir_fichero(&f_binario,"r+b",nombre_fichero_clientes);
	
	dato=busca_cliente(f_binario,nif_pedido);
	
	if(f_error(atoi(dato.nif)))
	{     		
		do
		{                     		
		    sacar_pantalla_cliente(dato);	
		    pausa();
		    opc=menu_modificar_cliente();
		
		    switch(opc)
		    {
		        case 5: do
		        	{
		        	   intr_cadena(nuevo_nif,"Nuevo nif");
		        	   dato2=busca_cliente(f_binario,nuevo_nif);
		        	
		        	   if(atoi(dato2.nif)==-4)
		        	   	strcpy(dato.nif,nuevo_nif);        			        	
		        	   else
		        	       f_error(-5);
      	
		        	}while(atoi(dato2.nif)!=-4);
		        	dato2=busca_cliente(f_binario,nif_pedido);
		        	/*dejamos el ptr a fichero donde estaba antes de entrar en case 5:
		        	para poder reescribir en sitio adecuado*/
		        	break;
		        	
		        case 1:	intr_cadena(dato.nombre,"Nombre");
                                break;
		        case 2:	intr_cadena(dato.apellido1,"Apellido 1");
		        	break;
		        case 3:	intr_cadena(dato.apellido2,"Apellido2");
				break;
		        case 4:	intr_cadena(dato.direccion,"Direccion");
		        	break;

		        default :f_error(-3);
		    }
		    getchar();
		    printf("\n\tDesea modificar mas campos ? (S/N) ");
		    respuesta=toupper(getchar());

		}while(respuesta=='S');
		
		system("clear");
		sacar_pantalla_cliente(dato);
		pausa();
		
		fseek(f_binario,-1*sizeof(cliente),SEEK_CUR);
         	fwrite(&dato,sizeof(cliente),1,f_binario);
	} /*fin if*/                	
	fclose(f_binario);	
}
/**************************************************************************
   Funcin:          eliminar_cliente

   Descripcin:      Pregunta el nif del cliente a retirar y llama a la funcion borrar
   		
   parametros recibidos:char *nombre_fichero_clientes-->

   Llamada a funciones:  abrir_fichero
   	                 busca_cliente
   			 f_error
   			 sacar_pantalla_cliente
   			 borrar_cliente                        	**********/

void eliminar_cliente(char * nombre_fichero_clientes)
{
  char nif_pedido[10],respuesta;
  cliente dato;
  FILE *f_binario;

  abrir_fichero(&f_binario,"r+b",nombre_fichero_clientes);
  intr_cadena(nif_pedido,"Codigo del cliente");
  system("clear");
  dato=busca_cliente(f_binario,nif_pedido);

  if(f_error(atoi(dato.nif)))
  {
   	sacar_pantalla_cliente(dato);	

        printf("\n\n\tDesea borrar este elemento? (S/N) ");
	respuesta=toupper(getchar());
   	
	if(respuesta=='S')
	   borrar_cliente(&f_binario,nif_pedido,nombre_fichero_clientes);

  }
  fclose(f_binario);

}
/**************************************************************************
   Funcin:          borrar_cliente

   Descripcin:      Borra un registro del fichero de clientes
   		
   parametros recibidos:char *nombre_fichero_original-->nombre del fichero clientes
   			FILE **f_original-->ptr a fichero que le pasamos abierto
   			char *nif_borrado--> nif del cliente a borrar	      ****/

void borrar_cliente(FILE **f_original,char *nif_borrado,char *nombre_fichero_original)
{
	FILE *temp;
	cliente dato;
	
	rewind(*f_original);	
        temp=fopen("temporal","wb");

        while((fread(&dato,sizeof(cliente),1,*f_original)!=0))
        {
           if(strcmp(dato.nif,nif_borrado)!=0)
        	fwrite(&dato,sizeof(cliente),1,temp);

        }
        fclose(*f_original);
        fclose(temp);

        remove(nombre_fichero_original);
        rename("temporal",nombre_fichero_original);

        *f_original=fopen(nombre_fichero_original,"r+b");
}
