#include "cabecera.h"

/**************************************************************************
   Funcin:          anadir_equipo

   Descripcin:      Aade equipo si este no existe,si existe pregunta el n
   		     de equipos nuevos a aadir

   parametros recibidos:char *f_equipo--> nombre del fichero de equipos

   Llamada a funciones:  abrir_fichero
   			 busca_equipo
   			 lee_equipo_teclado
   			 sacar_pantalla_equipo              	**********/

void anadir_equipo(char *f_equipo)
{
  equipo dato;
  char respuesta;
  int cod_pedido,unidades_nuevas;
  FILE *fichero;

  abrir_fichero(&fichero,"r+b",f_equipo);

  do
  {
     system("clear");
     intr_entero(&cod_pedido,"Codigo del equipo");
     dato=busca_equipo(fichero,cod_pedido);

     if(dato.codigo==-1)/** En el caso de no encontrar el equipo dev -1 en dato.codigo**/
     {
      	 dato=lee_equipo_teclado(cod_pedido);
         fseek(fichero,0,SEEK_END);/*desplazamos el puntero al final del fichero*/
         fwrite(&dato,sizeof(equipo),1,fichero);/*y lo aadimos*/
     }
     else
     {
     	 intr_entero(&unidades_nuevas,"n de nuevos equipos");
     	 dato.stock=dato.stock+unidades_nuevas;/*existe,modificamos el stock*/
     	 sacar_pantalla_equipo(dato);
     	 pausa();
     	 fseek(fichero,-1*sizeof(equipo),SEEK_CUR);/*ponemos el ptr en la posicion que*/
         fwrite(&dato,sizeof(equipo),1,fichero);/*acabamos de leer,para escribir nuevo*/
                                               /*equipo con nuevo stock*/
     }
     getchar();
     printf("\n\n\tDesea introducir mas equipos ? (S/N) ");
     respuesta=toupper(getchar());

  }while(respuesta=='S');

  fclose(fichero);

}
/**************************************************************************
   Funcin:          busca_equipo

   Descripcin:      busca en el fichero de equipos uno determinado,devolviendo
                     -1 en el campo codigo si no se encuentra.

   Valor devuelto:   equipo dato --> equipo buscado,o ultimo registro con -1 en campo
   		                     codigo

   parametros recibidos:FILE *f_binario--> ptr a fichero, se lo pasamos abierto fichero
   			int codigo --> codigo de equipo buscado

   Llamada a funciones:  ninguna                        	**********/

equipo busca_equipo(FILE *f_binario,int codigo)/*si*/
{
   equipo dato;
   int no_encontrado=0;    /**nos indicara si se ha encontrado**/

   rewind(f_binario);    /*si es un elemento no es necesario,pero con mas si*/
   while((fread(&dato,sizeof(equipo),1,f_binario))!=0)
   {
       if(dato.codigo==codigo)
       {
       	  no_encontrado=1;
       	  break;
       }
   }

   if(no_encontrado==0) /*Lo indicamos fuera de la funcion devolviendo en el */
   	dato.codigo=-1; /*codigo de la estructura un -1 */

   return (dato);
}
/**************************************************************************
   Funcin:          eliminar_n_equipos()

   Descripcin:      Retira un numero de equipos de un equipo determinado,borrando
   		     el registro si el n de equipos retirados es igual al stock
   		
   parametros recibidos:char *nombre_fichero_equipos-->

   Llamada a funciones:  abrir_fichero
   	                 busca_equipo
   			 f_error
   			 sacar_pantalla_equipo
   			 borrar_equipo                        	**********/

void eliminar_n_equipos(char * nombre_fichero_equipos)
{
  int cod_pedido,equipos_restados;
  equipo dato;
  FILE *f_binario;

  abrir_fichero(&f_binario,"r+b",nombre_fichero_equipos);
  intr_entero(&cod_pedido,"Codigo del equipo");

  dato=busca_equipo(f_binario,cod_pedido);

  if(f_error(dato.codigo)) /*entrara si existe*/
  {
   	sacar_pantalla_equipo(dato);
   	pausa();
   	
   	intr_entero(&equipos_restados,"Numero de equipos retirados");  	
   	
   	if((dato.stock-equipos_restados)<0) /*Fallo no hay tantos equipos para retirar*/
   		f_error(-2);	   	
   	else if((dato.stock-equipos_restados)>0)
   	{
   		dato.stock=dato.stock-equipos_restados;
   		fseek(f_binario,-1*sizeof(equipo),SEEK_CUR);/*ponemos el ptr en la posicion que*/
	        fwrite(&dato,sizeof(equipo),1,f_binario);/*acabamos de leer,para escribir nuevo*/
               		                               /*equipo con nuevo stock*/
   	}
   	else  /*la resta sera igual a cero*/
       	   borrar_equipo(&f_binario,cod_pedido,nombre_fichero_equipos);

  }
  fclose(f_binario);

}
/**************************************************************************
   Funcin:          borrar_equipo()

   Descripcin:      Borra un registro del fichero de equipos
   		
   parametros recibidos:char *nombre_fichero_original-->nombre del fichero equipos
   			FILE **f_original-->ptr a fichero que le pasamos abierto
   			int cod_borrado--> codigo del equipo a borrar	      ****/

void borrar_equipo(FILE **f_original,int cod_borrado,char *nombre_fichero_original)
{
	FILE *temp;
	equipo dato;
	
	rewind(*f_original);	
        temp=fopen("temporal","wb");

        while((fread(&dato,sizeof(equipo),1,*f_original)!=0))
        {
           if(dato.codigo!=cod_borrado)
        	fwrite(&dato,sizeof(equipo),1,temp);

        }
        fclose(*f_original);
        fclose(temp);

        remove(nombre_fichero_original);
        rename("temporal",nombre_fichero_original);

        *f_original=fopen(nombre_fichero_original,"r+b");
}
/**************************************************************************
   Funcin:          listar_equipos()

   Descripcin:      Lista el fichero de equipos completo

   parametros recibidos:char *nombre_fichero_binario-->nombre del fichero a listar

   Llamada a funciones:  abrir_fichero
   	                  f_error
   			 sacar_pantalla_equipo
   			                         	**********/
void listar_equipos(char nombre_fichero_binario[10])
{
     int opc;
     char nombre_fichero_texto[10];
     FILE *f_binario,*f_texto;
     equipo dato;

     opc=menu_listar();
     abrir_fichero(&f_binario,"rb",nombre_fichero_binario);

     switch(opc)
     {
           case 1:     /*por pantalla*/
                  while((fread(&dato,sizeof(equipo),1,f_binario))!=0)
                  {
                      system("clear");           	
           	      sacar_pantalla_equipo(dato);
                      pausa();
                  }
           	  break;
                         /*a fichero de texto*/
           case 2:intr_cadena(nombre_fichero_texto,"Nombre del fichero de salida");         	
           	  f_texto=fopen(nombre_fichero_texto,"w");

                  while((fread(&dato,sizeof(equipo),1,f_binario))!=0)
                  {
           	      fprintf(f_texto,"Codigo :%d\nNombre:%s\nProcesador:%s\nMemoria:%d\nStock:%d\nPrecio%f\n\n",dato.codigo,dato.nombre,dato.procesador,dato.memoria,dato.stock,dato.precio);
                  }
                  fclose(f_texto);
                  break;

           case 3:break;

           default :f_error(-3);
     }
     fclose(f_binario);
}
/**************************************************************************
   Funcin:          listar_equipo_por_codigo()

   Descripcin:      Dado un codigo de un equipo,lo lista por pantalla o lo vuelca
   		     a fichero de texto.
   		
   parametros recibidos:char *nombre_fichero_binario-->nombre de fchero de equipos

   Llamada a funciones:  abrir_fichero
   	                 busca_equipo
   	                 menu_listar
   			 f_error
   			 sacar_pantalla_equipo                        	**********/

void lista_equipo_por_codigo(char *nombre_fichero_binario)
{
     int opc,cod_pedido;
     char nombre_fichero_texto[10];
     FILE *f_binario,*f_texto;
     equipo dato;

     abrir_fichero(&f_binario,"rb",nombre_fichero_binario);
     intr_entero(&cod_pedido,"codigo del equipo");

     dato=busca_equipo(f_binario,cod_pedido);

     if(f_error(dato.codigo))
     {
     	opc=menu_listar();
     	
     	switch(opc)
     	{                           /*por pantalla*/
             case 1:system("clear");
             	    sacar_pantalla_equipo(dato);
                    pausa();
	            break;
                                  /*volcado a fichero de texto*/
	     case 2:intr_cadena(nombre_fichero_texto,"Nombre del fichero de salida");
                    f_texto=fopen(nombre_fichero_texto,"w");
 	            fprintf(f_texto,"Codigo :%d\nNombre:%s\nProcesador:%s\nMemoria:%d\nStock:%d\nPrecio%f\n\n",dato.codigo,dato.nombre,dato.procesador,dato.memoria,dato.stock,dato.precio);
                    fclose(f_texto);
                    break;

             case 3:break;
             default:f_error(-3);
        }
     }
     fclose(f_binario);
}
/**************************************************************************
   Funcin:          modificar_equipo()

   Descripcin:      Busca un equipo y modifica cualquiera de los campos de su estructura
   		
   parametros recibidos:char *nombre_fichero_equipos-->

   Llamada a funciones:  abrir_fichero
   	                 busca_equipo
   			 f_error
   			 sacar_pantalla_equipo
   			 menu_modificar_equipo                        	**********/

void modificar_equipo(char *nombre_fichero_equipos)
{
	int codigo,opc,entero,nuevo_cod;
	char cadena[15];
	char respuesta;
	equipo dato,dato2;     /*dato2 actuara de auxiliar*/
	FILE *f_binario;
	
        intr_entero(&codigo,"codigo del equipo a modificar");
	
	abrir_fichero(&f_binario,"r+b",nombre_fichero_equipos);
	dato=busca_equipo(f_binario,codigo);
	
	if(f_error(dato.codigo))
	{     		
		do
		{                     		
		    sacar_pantalla_equipo(dato);	
		    pausa();
		    opc=menu_modificar_equipo();
		
		    switch(opc)
		    {
		        case 1: do
		        	{  		        	
		        	   intr_entero(&nuevo_cod,"Codigo");
		        	   dato2=busca_equipo(f_binario,nuevo_cod);
		        	
		        	   if(dato2.codigo==-1) /*No existe un codigo igual,luego lo*/   	
		        	   	dato.codigo=nuevo_cod;/*lo aceptamos*/      	   	     		        	
		        	   else
		        	       f_error(-8);
		        	       		        	
		        	}while(dato2.codigo!=-1);
		        	dato2=busca_equipo(f_binario,codigo);
		        	/*volvemos a dejar el puntero donde estaba antes de entrar en */
		        	/*case 1,ya que lo hemos movido y no escribiria en sitio adecuado*/
		        	break;
		        	
		        case 2:	intr_cadena(dato.nombre,"Nombre");
                                break;
		        case 3:	intr_cadena(dato.procesador,"Tipo de procesador");
		        	break;
		        case 4:	intr_entero(&dato.memoria,"Tamano memoria");
				break;
		        case 5:	intr_entero(&dato.stock,"Unidades stock");
		        	break;
		        case 6:	intr_float(&dato.precio,"Precio");
		        	break;

		        default :f_error(-3);
		    }
		    getchar();
		    printf("\n\tDesea modificar mas campos ? (S/N) ");
		    respuesta=toupper(getchar());

		}while(respuesta=='S');
		
		sacar_pantalla_equipo(dato);
		pausa();
		
		fseek(f_binario,-1*sizeof(equipo),SEEK_CUR);/*mueve el ptr a la posicion*/
         	fwrite(&dato,sizeof(equipo),1,f_binario);/*donde esta el registro sin modificar*/
	}                 	                         /*y escribe encima*/
	fclose(f_binario);	
}
/**************************************************************************
   Funcin:          actualiza_stock

   Descripcin:      resta unidades vendidas al stock de un equipo

   parametros recibidos:int ventas --> numero de equipos vendidos
                        char *nombre_f_equipos--> nombre del fichero de equipos
                        int codigo --> codigo del equipo vendido

   Llamada a funciones:  abrir_fichero
   	                 busca_equipo                        	**********/

void actualiza_stock(char *nombre_f_equipos,int ventas,int codigo)
{
     FILE *f_equipos;
     equipo dato;

     abrir_fichero(&f_equipos,"r+b",nombre_f_equipos);
         	
     dato=busca_equipo(f_equipos,codigo);

     if(dato.stock!=-1)/*si no lo encuentra es que habiamos agotado existencias*/
     {                 /*luego no lo escribimos en fichero equipos*/
        dato.stock=dato.stock-ventas;
        fseek(f_equipos,-1*sizeof(equipo),SEEK_CUR);
        fwrite(&dato,sizeof(equipo),1,f_equipos);
     }
     fclose(f_equipos);
}    	